﻿Option Strict Off
Imports System
Imports System.IO
Imports System.Windows.Forms
Imports NXOpen
Imports NXOpen.UF
Imports NXOpenUI
Imports NXOpen.Utilities
Imports NXOpen.Features
Module HolePointFeature
    Dim s As Session = Session.GetSession()
    Dim ui As UI = UI.GetUI()
    Dim ufs As UFSession = UFSession.GetUFSession()
    Dim wp As Part = s.Parts.Work
    Sub Main()
        Dim response1 As Selection.Response = Nothing
        Dim pt1(2) As Double
        Dim faceTag As Tag = Nothing
        Dim face1 As Face = Nothing
        Dim holeDia As String = Nothing
        Dim parm(1) As Double
        Dim facept(2) As Double
        Dim junk3(2) As Double
        Dim junk2(1) As Double
        Dim holeobj1 As NXObject = Nothing
        Dim bodyTag As Tag = Tag.Null
        Dim cylbody As Body = Nothing
        Dim point2 As Point = Nothing
        Dim nullXform As Xform = Nothing
        
Start1:
        response1 = select_a_face("Select the face", faceTag)
        If response1 = Selection.Response.Back Then GoTo End1
        If response1 = Selection.Response.Cancel Then GoTo End1
        face1 = NXObjectManager.Get(faceTag)
        Try
            ufs.Modl.AskFaceBody(faceTag, bodyTag)
            cylbody = NXObjectManager.Get(bodyTag)
            Dim openFileDialog1 As New OpenFileDialog()
            openFileDialog1.Filter = "Data Files (*.dat)|*.dat|All files (*.*)|*.*"
            openFileDialog1.FilterIndex = 1
            openFileDialog1.RestoreDirectory = True
            If openFileDialog1.ShowDialog() = DialogResult.OK Then
                Dim sr As StreamReader = New StreamReader(openFileDialog1.FileName)
                Dim linestring As String
                Dim testArray() As String
                Dim pointObj As Point
                Dim temptag As Tag = Tag.Null

                Try
                    Do While sr.Peek >= 0
                        linestring = sr.ReadLine
                        If linestring.Length = 0 Then Exit Do
                        testArray = Split(linestring, vbTab, 3)
                        pt1(0) = CDbl(testArray(0))
                        pt1(1) = CDbl(testArray(1))
                        pt1(2) = CDbl(testArray(2))
                        ufs.Modl.AskFaceParm(faceTag, pt1, parm, facept)
                        '    MsgBox(parm(0).ToString & " , " & parm(1).ToString)
                        ufs.Modl.AskFaceProps(faceTag, parm, facept, junk3, junk3, junk3, junk3, junk3, junk2)
                        Dim point1 As Point3d = New Point3d(facept(0), facept(1), facept(2))
                        pointObj = wp.Points.CreatePoint(point1)
                        '  ufs.Curve.CreatePoint(facept, temptag)
                        point2 = wp.Points.CreatePoint(pointObj, nullXform, SmartObject.UpdateOption.WithinModeling)
                        CreatePointFeature(pointObj, face1, parm)
                        holeobj1 = SimpleHole1(wp, cylbody, pointObj)
                    Loop
                Finally
                    sr.Close()
                End Try
            End If
        Catch E As Exception
            MessageBox.Show(E.Message)
            Exit Sub
        End Try
End1:
    End Sub

    Public Function mask_for_face(ByVal select_ As IntPtr, ByVal userdata As IntPtr) As Integer
        Dim num_triples As Integer = 1
        Dim mask_triples(0) As UFUi.Mask
        mask_triples(0).object_type = UFConstants.UF_solid_type
        mask_triples(0).object_subtype = 0
        mask_triples(0).solid_type = UFConstants.UF_UI_SEL_FEATURE_ANY_FACE
        ufs.Ui.SetSelMask(select_, _
                UFUi.SelMaskAction.SelMaskClearAndEnableSpecific, _
                                          num_triples, mask_triples)
        Return UFConstants.UF_UI_SEL_SUCCESS
    End Function

    Public Function select_a_face(ByVal prompt As String, ByRef facetag As NXOpen.Tag) As Selection.Response
        Dim resp As Integer = 0
        Dim cp(2) As Double
        Dim theView As NXOpen.Tag = NXOpen.Tag.Null
        Dim mask_face As UFUi.SelInitFnT = AddressOf mask_for_face
        ufs.Ui.LockUgAccess(UFConstants.UF_UI_FROM_CUSTOM)
        ufs.Ui.SelectWithSingleDialog("Select a face", prompt, _
                    UFConstants.UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY, _
                     mask_face, Nothing, resp, facetag, cp, theView)
        ufs.Ui.UnlockUgAccess(UFConstants.UF_UI_FROM_CUSTOM)
        ufs.Disp.SetHighlight(facetag, 0)
        If resp = UFConstants.UF_UI_OBJECT_SELECTED Or _
           resp = UFConstants.UF_UI_OBJECT_SELECTED_BY_NAME Then
            Return resp
        End If
        Return resp
    End Function

    Function SimpleHole1(ByVal part1 As Part, ByVal body1 As Body, ByVal point2 As Point) As NXObject
        Dim nullFeatures_HolePackage As Features.HolePackage = Nothing
        Dim holePackageBuilder1 As Features.HolePackageBuilder
        holePackageBuilder1 = part1.Features.CreateHolePackageBuilder(nullFeatures_HolePackage)
        holePackageBuilder1.GeneralHoleForm = Features.HolePackageBuilder.HoleForms.Simple
        holePackageBuilder1.GeneralSimpleHoleDiameter.RightHandSide = "10.0"
        holePackageBuilder1.HoleDepthLimitOption = Features.HolePackageBuilder.HoleDepthLimitOptions.Value
        holePackageBuilder1.GeneralSimpleHoleDepth.RightHandSide = "20.0"
        holePackageBuilder1.Tolerance = 0.001
        holePackageBuilder1.GeneralTipAngle.RightHandSide = "118"

        Dim targetbodies1() As Body = {body1}
        holePackageBuilder1.BooleanOperation.SetTargetBodies(targetbodies1)
        holePackageBuilder1.BooleanOperation.Type = GeometricUtilities.BooleanOperation.BooleanType.Subtract
        holePackageBuilder1.BooleanOperation.SetTargetBodies(targetbodies1)
        Dim nullXform As Xform = Nothing
        holePackageBuilder1.HolePosition.AddSmartPoint(point2, 0.001)
        Dim nXObject2 As NXObject
        nXObject2 = holePackageBuilder1.Commit()
        Return nXObject2
    End Function

    Sub CreatePointFeature(ByRef point2 As Point, ByVal face1 As Face, ByVal parms() As Double)
        Dim pointFeatureBuilder1 As Features.PointFeatureBuilder
        Dim nullFeatures_Feature As Features.Feature = Nothing
        pointFeatureBuilder1 = wp.BaseFeatures.CreatePointFeatureBuilder(nullFeatures_Feature)
        Dim nullUnit As Unit = Nothing
        Dim expression1 As Expression
        expression1 = wp.Expressions.CreateSystemExpressionWithUnits(parms(0).ToString, nullUnit)

        Dim expression2 As Expression
        expression2 = wp.Expressions.CreateSystemExpressionWithUnits(parms(1).ToString, nullUnit)

        Dim scalar1 As Scalar
        scalar1 = wp.Scalars.CreateScalarExpression(expression1, Scalar.DimensionalityType.None, SmartObject.UpdateOption.WithinModeling)

        Dim scalar2 As Scalar
        scalar2 = wp.Scalars.CreateScalarExpression(expression2, Scalar.DimensionalityType.None, SmartObject.UpdateOption.WithinModeling)
        point2 = wp.Points.CreatePoint(face1, scalar1, scalar2, SmartObject.UpdateOption.WithinModeling)
        pointFeatureBuilder1.Point = point2
        Dim nXObject1 As NXObject
        nXObject1 = pointFeatureBuilder1.Commit()
        pointFeatureBuilder1.Destroy()
    End Sub
    Public Function GetUnloadOption(ByVal arg As String) As Integer
        Return CType(Session.LibraryUnloadOption.Immediately, Integer)
    End Function
End Module
